CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)
PROJECT(hphp C CXX ASM)

set(HHVM_DEFINITIONS "HAVE_LIBDL;PHP_MYSQL_UNIX_SOCK_ADDR=\"/tmp/mysql.sock\";HAVE_CURL_MULTI_WAIT;USE_JEMALLOC=1;NO_TCMALLOC=1;USE_EDITLINE;HHVM;HAVE_LIBSODIUM;THRIFT_MUTEX_EMULATE_PTHREAD_TIMEDLOCK;HHVM_DYNAMIC_EXTENSION_DIR=\"@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/lib/hhvm/extensions\";HHVM_VERSION_OVERRIDE;HHVM_VERSION_MAJOR=3;HHVM_VERSION_MINOR=21;HHVM_VERSION_PATCH=5;HHVM_VERSION_SUFFIX=\"-0brew\";_REENTRANT=1;_PTHREADS=1;__STDC_FORMAT_MACROS;RELEASE=1;NDEBUG;SKIP_USER_CHANGE=1;MAC_OS_X_VERSION_MIN_REQUIRED=MAC_OS_X_VERSION_10_6;MACOSX_DEPLOYMENT_TARGET=10.6;ENABLE_FASTCGI=1;NO_HARDWARE_COUNTERS=1;HPHP_OSS=1;PACKAGE=hhvm;PACKAGE_VERSION=Release;DEFAULT_CONFIG_DIR=\"@@HOMEBREW_PREFIX@@/etc/hhvm\";HAVE_INTTYPES_H;USE_CMAKE;HAVE_LIBBZIP2;HAVE_LIBCURL;HAVE_LIBXML2;HAVE_LIBICU;HAVE_LIBFREETYPE;HAVE_GD_FREETYPE;ENABLE_GD_TTF;HAVE_LIBJPEG;HAVE_GD_JPG;HAVE_ICONV;HAVE_LIBICONV;HAVE_LIBPNG;HAVE_GD_PNG;PNG_SKIP_SETJMP_CHECK;HAVE_LIBINTL;HAVE_LIBGMP;HAVE_LIBMAGICKWAND;HAVE_LIBLDAP;HAVE_LIBMCRYPT;HAVE_LIBMEMCACHED;ENABLE_ASYNC_MYSQL=1;HAVE_LIBEXPAT;HAVE_LIBXSLT;FOLLY_HAVE_MALLOC_H=0;FOLLY_NO_CONFIG=1;FOLLY_HAVE_PTHREAD=1;FOLLY_HAVE_CLOCK_GETTIME=1;FOLLY_HAVE_PTHREAD_ATFORK=1;FOLLY_HAVE_PTHREAD_SPINLOCK_T=0;FOLLY_USE_LIBCPP=1;FOLLY_HAVE_LIBDWARF_DWARF_H=0;FOLLY_HAVE_VLA=1;FOLLY_HAVE_IFUNC=0;FOLLY_HAVE_BITS_FUNCTEXCEPT_H=0;FOLLY_HAVE_LINUX_MEMBARRIER_H=0;FOLLY_HAVE_WEAK_SYMBOLS=1;FOLLY_HAVE_MEMRCHR=0;FOLLY_HAVE_PREADV=0;FOLLY_HAVE_PWRITEV=0;FOLLY_HAVE_LIBGFLAGS=0;NO_LIB_GFLAGS;FOLLY_HAVE_SCHED_H=1")
set(HHVM_VERSION_BRANCH "32052")
set(CMAKE_INSTALL_PREFIX "@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5")
set(CMAKE_INSTALL_LIBDIR "lib")
set(CMAKE_BUILD_TYPE "Release")
set(ENABLE_ZEND_COMPAT "")

option(HHVM_DSO_TEST_MODE "Build against source headers, not installed ones" Off)
if (HHVM_DSO_TEST_MODE)
  set(HHVM_INCLUDE_DIRS "/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5;/usr/include;@@HOMEBREW_PREFIX@@/opt/glog/include;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/squangle/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/webscalesqlclient/src/include;@@HOMEBREW_PREFIX@@/opt/pcre/include;@@HOMEBREW_PREFIX@@/opt/libevent/include;@@HOMEBREW_PREFIX@@/opt/libxml2/include/libxml2;@@HOMEBREW_PREFIX@@/opt/lz4/include;@@HOMEBREW_PREFIX@@/opt/libzip/include;@@HOMEBREW_PREFIX@@/opt/libzip/lib/libzip/include;@@HOMEBREW_PREFIX@@/opt/icu4c/include;@@HOMEBREW_PREFIX@@/opt/jemalloc/include;@@HOMEBREW_PREFIX@@/opt/tbb/include;@@HOMEBREW_PREFIX@@/opt/openssl/include;@@HOMEBREW_PREFIX@@/opt/oniguruma/include;@@HOMEBREW_PREFIX@@/opt/dwarfutils/include;@@HOMEBREW_PREFIX@@/opt/libelf/include/libelf;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/hphp;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/re2/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/libmbfl;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/libmbfl/mbfl;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/libmbfl/filters;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/timelib;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/folly/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/fatal;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/wangle/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/brotli/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/proxygen/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/thrift/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/zstd/src/lib;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/zstd/src/lib/dictBuilder;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/libafdt/src/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/fastlz/src;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/double-conversion;@@HOMEBREW_PREFIX@@/opt/freetype/include/freetype2;@@HOMEBREW_PREFIX@@/opt/jpeg/include;@@HOMEBREW_PREFIX@@/opt/libpng/include;@@HOMEBREW_PREFIX@@/opt/gettext/include;@@HOMEBREW_PREFIX@@/opt/gmp/include;@@HOMEBREW_PREFIX@@/opt/imagemagick@6/include/ImageMagick-6;@@HOMEBREW_PREFIX@@/opt/mcrypt/include;@@HOMEBREW_PREFIX@@/opt/libmemcached/include;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/squangle/src/;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/webscalesqlclient/src/include/;@@HOMEBREW_PREFIX@@/Cellar/libsodium/1.0.16/include;/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/third-party/folly")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/CMake" "/tmp/hhvm@3.21-lts-20180112-67468-51alkz/hhvm-3.21.5/hphp/public_tld/CMake"
    ${CMAKE_MODULE_PATH})
else()
  set(HHVM_INCLUDE_DIRS "@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include;/usr/include;@@HOMEBREW_PREFIX@@/opt/glog/include;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/squangle/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/webscalesqlclient/src/include;@@HOMEBREW_PREFIX@@/opt/pcre/include;@@HOMEBREW_PREFIX@@/opt/libevent/include;@@HOMEBREW_PREFIX@@/opt/libxml2/include/libxml2;@@HOMEBREW_PREFIX@@/opt/lz4/include;@@HOMEBREW_PREFIX@@/opt/libzip/include;@@HOMEBREW_PREFIX@@/opt/libzip/lib/libzip/include;@@HOMEBREW_PREFIX@@/opt/icu4c/include;@@HOMEBREW_PREFIX@@/opt/jemalloc/include;@@HOMEBREW_PREFIX@@/opt/tbb/include;@@HOMEBREW_PREFIX@@/opt/openssl/include;@@HOMEBREW_PREFIX@@/opt/oniguruma/include;@@HOMEBREW_PREFIX@@/opt/dwarfutils/include;@@HOMEBREW_PREFIX@@/opt/libelf/include/libelf;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/re2/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/libmbfl;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/libmbfl/mbfl;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/libmbfl/filters;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/timelib;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/folly/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/fatal;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/wangle/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/brotli/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/proxygen/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/thrift/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/zstd/src/lib;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/zstd/src/lib/dictBuilder;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/libafdt/src/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/fastlz/src;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/double-conversion;@@HOMEBREW_PREFIX@@/opt/freetype/include/freetype2;@@HOMEBREW_PREFIX@@/opt/jpeg/include;@@HOMEBREW_PREFIX@@/opt/libpng/include;@@HOMEBREW_PREFIX@@/opt/gettext/include;@@HOMEBREW_PREFIX@@/opt/gmp/include;@@HOMEBREW_PREFIX@@/opt/imagemagick@6/include/ImageMagick-6;@@HOMEBREW_PREFIX@@/opt/mcrypt/include;@@HOMEBREW_PREFIX@@/opt/libmemcached/include;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/squangle/src/;@@HOMEBREW_PREFIX@@/Cellar/hhvm@3.21-lts/3.21.5/include/hphp/third-party/webscalesqlclient/src/include/;@@HOMEBREW_PREFIX@@/Cellar/libsodium/1.0.16/include")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
    ${CMAKE_MODULE_PATH})
endif()

message(STATUS "Configuring for HHVM API version ${HHVM_VERSION_BRANCH}")

include(HPHPFunctions)
include(HPHPIZEFunctions)
include(HPHPCompiler)
include(config)

foreach (dir ${HHVM_INCLUDE_DIRS})
  include_directories(${dir})
endforeach()

add_definitions("-DHHVM_BUILD_DSO")
foreach (def ${HHVM_DEFINITIONS})
  add_definitions("-D${def}")
endforeach()

add_custom_target(test COMMAND
                       HHVM_BIN=${CMAKE_INSTALL_PREFIX}/bin/hhvm
                       ${CMAKE_CURRENT_SOURCE_DIR}/run-test
                       -a "-vDynamicExtensions.99=${EXTENSION_NAME}.so" test
                       DEPENDS ${EXTENSION_NAME})
